
/* this .csd loads a beat file (Tambourine.wav) using diskin
   and replaces the even beats with a clap using Vaget/Vaset.  
   Inst5 uses multiple conditional if...elseif statements with 
   kndx numbers for the sample indexes within loop_lt.

   could all be done in a UDO, but left undone here to show
   beginning steps.
*/

<CsoundSynthesizer>
<CsOptions>

-s -d -+rtaudio=PortAudio -odac4 -W -b1024 -B16384

</CsOptions>
<CsInstruments>


sr=44100
ksmps=176400
nchnls=1

gitmp1    ftgen 100, 0, -176400, -10, 1

gatamb init 0
gaclap init 0

gilen1 filelen "Tambourine.wav"
gilen2 filelen "Clap0.wav"
gisamples1 init 0
gisamples2 init 0

;==========================
  instr 1
;GET TAMBOURINE.wav info (8 beats, 22050 samples each beat)
;total file 176400 samples

print gilen1
gisamples1 = gilen1 * sr
print gisamples1
    endin
;==============
    instr 2
;GET CLAP
;load the clap sample into a table (100) and save it to .wav file
;the same length as tambourine beats.

andx line 0, gilen1, gisamples1 ;using length from above

asig2 diskin "Clap0.wav", 1, 0, 0, 4
tablew asig2, andx, 100
    endin
;=================
	instr 3
andx line 0, gilen1, gisamples1 ;using length from above
a1 table andx, 100
gaclap= gaclap + a1
	endin

	instr 4
fout "Longclap.wav", 2, gaclap
fout "/opt/csound5109/JFiles/Longclap.wav", 2, gaclap
	endin
;=================
;=================
	instr 5
a1 init 0
a2 init 0
a3 init 0

a1 diskin "Tambourine.wav", 1, 0, 0, 4
a2 diskin "Longclap.wav", 1, 0, 0, 4

kval init 0
kndx = 0

/*
beat  - smplnum
beat1 - 0
beat2 - 22050
beat3 - 44100
beat4 - 66150
beat5 - 88200
beat6 - 110250
beat7 - 132300
beat8 - 154350
EOF   - 176400
*/

loopStart1:

	;beat one
	if (kndx > 0 && kndx < 22049) then
	kval vaget kndx,a1
	
	;beat two *
	elseif (kndx > 22049 && kndx < 44099) then
	kval vaget kndx - 22049, a2

	;beat three
	elseif (kndx > 44099 && kndx < 66139) then
	kval vaget kndx,a1 

	;beat four *
	elseif (kndx > 66149 && kndx < 88199) then
	kval vaget kndx - 66149, a2
	
	;beat five
	elseif (kndx > 88199 && kndx < 110249) then
	kval vaget kndx,a1 

	;beat six *
	elseif (kndx > 110249 && kndx < 132299) then
	kval vaget kndx - 110249,a2

	;beat seven
	elseif (kndx > 132299 && kndx < 154349) then
	kval vaget kndx,a1 

	;beat eight *
	elseif (kndx > 154349) then
	kval vaget kndx - 154349,a2 
	endif
	
	vaset kval,kndx,a3
	
	if (kndx >176400) goto last;	
loop_lt kndx, 1, ksmps, loopStart1

last:
	;out a3
	gatamb = gatamb + a3
	printf "inst5 turnedoff at  %d\n", 1, kndx
	turnoff
	endin
;=================
;=================
	instr 6
;fout "/opt/csound5109/JFiles/Samplereplace.wav", 2, gatamb
fout "Samplereplace.wav", 2, gatamb
	endin

</CsInstruments>
<CsScore>

f1 0 -176400 1 "Tambourine.wav" 0 4 0 
f2 0 -22050 1 "Clap0.wav" 0 4 0 	


i1	0	5
s
i2	0	5
s
i3	0	5
s
i4	0	5
s
i5	0	5
s
i6	0	5

e


</CsScore>
</CsoundSynthesizer>

